Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 5310)
+++ src/perl/register-dataset.cgi	(revision 5311)
@@ -186,341 +198,468 @@
 #exit;
 # Set up the template information that is common to all forms
 
-$$templateVars{'contextUrl'} = $contextUrl;
-$$templateVars{'styleSkinsPath'} = $styleSkinsPath;
+$$templateVars{'contextUrl'}      = $contextUrl;
+$$templateVars{'styleSkinsPath'}  = $styleSkinsPath;
 $$templateVars{'styleCommonPath'} = $styleCommonPath;
-$$templateVars{'cgiPrefix'} = $cgiPrefix;
-$$templateVars{'metacatUrl'} = $metacatUrl;
-$$templateVars{'cfg'} = $skinName;
-$$templateVars{'email'} = $email;
-$$templateVars{'templates'} = $templates;
-$$templateVars{'required'} = $required;
-$$templateVars{'config'} = $config;
+$$templateVars{'cgiPrefix'}       = $cgiPrefix;
+$$templateVars{'metacatUrl'}      = $metacatUrl;
+$$templateVars{'cfg'}             = $skinName;
+$$templateVars{'email'}           = $email;
+$$templateVars{'templates'}       = $templates;
+$$templateVars{'required'}        = $required;
+$$templateVars{'config'}          = $config;
 
 debug("Initialized -- stage set: $FORM::stage");
 
-# Process the form based on stage parameter. 
-if ($FORM::stage =~ "loginform") {
-    print "Content-type: text/html\n\n";
-    # Send back the login form.....
-    my $session = CGI::Session->load() or die CGI::Session->errstr();
+# Process the form based on stage parameter.
+if ( $FORM::stage =~ "loginform" ) {
+	print "Content-type: text/html\n\n";
 
-    if ($FORM::submission eq 'true') {
-        $$templateVars{'message'} = 'You must login to view your submissions.';
-    }
+	# Send back the login form.....
+	my $session = CGI::Session->load() or die CGI::Session->errstr();
 
-    if (!$session->is_empty) {
-        # session found ... delete the session....
-        $session->delete();
-    }
+	if ( $FORM::submission eq 'true' ) {
+		$$templateVars{'message'} = 'You must login to view your submissions.';
+	}
 
-    $template->process($templates->{'login'}, $templateVars);
-    exit();
-} elsif ($FORM::stage =~ "logout") {
-    handleLogoutRequest();
-    exit();
-} elsif ($FORM::stage =~ "login") {
-    handleLoginRequest();
-    exit();
-} elsif ($FORM::stage =~ "mod_accept") {
-    handleModAccept();
-    exit();
-} elsif ($FORM::stage =~ "mod_decline") {
-    handleModDecline();
-    exit();
-} elsif ($FORM::stage =~ "mod_revise") {
-    handleModRevise();
-    exit();
-} elsif ($FORM::stage =~ "read") {
-    handleRead();
-    exit();
-} elsif ($FORM::stage =~ "review_frame") {
-    handleReviewFrame();
-    exit();
+	if ( !$session->is_empty ) {
+
+		# session found ... delete the session....
+		$session->delete();
+	}
+
+	$template->process( $templates->{'login'}, $templateVars );
+	exit();
 }
+elsif ( $FORM::stage =~ "logout" ) {
+	handleLogoutRequest();
+	exit();
+}
+elsif ( $FORM::stage =~ "login" ) {
+	handleLoginRequest();
+	exit();
+}
+elsif ( $FORM::stage =~ "mod_accept" ) {
+	handleModAccept();
+	exit();
+}
+elsif ( $FORM::stage =~ "mod_decline" ) {
+	handleModDecline();
+	exit();
+}
+elsif ( $FORM::stage =~ "mod_revise" ) {
+	handleModRevise();
+	exit();
+}
+elsif ( $FORM::stage =~ "read" ) {
+	handleRead();
+	exit();
+}
+elsif ( $FORM::stage =~ "review_frame" ) {
+	handleReviewFrame();
+	exit();
+}
 
 print "Content-type: text/html\n\n";
 
-if ($FORM::stage =~ "guide") {
-    # Send back the information on how to fill the form
-    $$templateVars{'section'} = "Guide on How to Complete Registry Entries";
-    $template->process($templates->{'guide'}, $templateVars);
-    exit();
+if ( $FORM::stage =~ "guide" ) {
 
-} elsif ($FORM::stage =~ "insert") {
-    # The user has entered the data. Do data validation and send back data 
-    # to confirm the data that has been entered. 
-    toConfirmData();
-    exit();
+	# Send back the information on how to fill the form
+	$$templateVars{'section'} = "Guide on How to Complete Registry Entries";
+	$template->process( $templates->{'guide'}, $templateVars );
+	exit();
 
-} elsif ($FORM::dataWrong =~ "No, go back to editing" && $FORM::stage =~ "confirmed") {
-    # The user wants to correct the data that he has entered. 
-    # Hence show the data again in entryData form. 
-    confirmDataToReEntryData();
-    exit();
+}
+elsif ( $FORM::stage =~ "insert" ) {
 
-} elsif ($FORM::stage =~ "modify") {
-    # Modification of a file has been requested. 
-    # check if the user is logged in...
-    my $session = CGI::Session->load() or die CGI::Session->errstr();
-    if ($session->is_empty) {
-        # no session found ... redirect to login page template
-        $$templateVars{'message'} = 'You must login to modify your dataset.';
-        $template->process($templates->{'login'}, $templateVars);
-    } else {
-        # Show the form will all the values filled in.
-        my @sortedSites;
-        foreach my $site (sort @sitelist) {
-            push(@sortedSites, $site);
-        }
-        $$templateVars{'siteList'} = \@sortedSites;
-        $$templateVars{'section'} = "Modification Form";
-        my ($foundScope, $id, $rev) = split(/\./, $FORM::docid);
-        if (! $rev) {
-        	my $metacat = Metacat->new($metacatUrl);
-        	my $lastRev = $metacat->getLastRevision($FORM::docid);
-        	$$templateVars{'docid'} = $FORM::docid . "." . $lastRev
-        } else {
-        	$$templateVars{'docid'} = $FORM::docid;
-        }
-        modifyData();
-    }
-    exit();
+	# The user has entered the data. Do data validation and send back data
+	# to confirm the data that has been entered.
+	toConfirmData();
+	exit();
 
-} elsif ($FORM::stage =~ "delete_confirm") {
+}
+elsif ($FORM::dataWrong =~ "No, go back to editing"
+	&& $FORM::stage =~ "confirmed" )
+{
 
-    # Result from deleteData form. 
-    if ($FORM::deleteData =~ "Delete document") {
-        # delete Data
-        deleteData(1);
-        exit();
-    } else {
-        $$templateVars{'status'} = "Cancel";
-        $$templateVars{'function'} = "cancel";
-        $template->process($templates->{'response'}, $templateVars);
-        exit();
-    }
+	# The user wants to correct the data that he has entered.
+	# Hence show the data again in entryData form.
+	confirmDataToReEntryData();
+	exit();
 
-} elsif ($FORM::stage =~ "delete") {
-    # Deletion of a file has been requested. 
-    # Ask for username and password using deleteDataForm
-    $$templateVars{'docid'} = $FORM::docid;
-    $template->process($templates->{'deleteData'}, $templateVars);
-    exit();
+}
+elsif ( $FORM::stage =~ "modify" ) {
+	#debug("in modify stage");
+	# Modification of a file has been requested.
+	# check if the user is logged in...
+	my $session = CGI::Session->load() or die CGI::Session->errstr();
+	if ( $session->is_empty ) {
 
-} elsif ($FORM::stage !~ "confirmed") {
-    # None of the stages have been reached and data is not being confirmed. 
+		# no session found ... redirect to login page template
+		$$templateVars{'message'} = 'You must login to modify your dataset.';
+		$template->process( $templates->{'login'}, $templateVars );
+	}
+	else {
 
-    # check if the user is logged in...
-    my $session = CGI::Session->load() or die CGI::Session->errstr();
-    if ($session->is_empty) {
-        # no session found ... redirect to login page template
-        $$templateVars{'showInstructions'} = 'true';
-        $$templateVars{'message'} = 'You must login to register your dataset.';
-        $template->process($templates->{'login'}, $templateVars);
-    } else {
+		# Show the form will all the values filled in.
+		my @sortedSites;
+		foreach my $site ( sort @sitelist ) {
+			push( @sortedSites, $site );
+		}
+		$$templateVars{'siteList'} = \@sortedSites;
+		$$templateVars{'section'}  = "Modification Form";
+		my ( $foundScope, $id, $rev ) = split( /\./, $FORM::docid );
+		if ( !$rev ) {
+			my $metacat = Metacat->new($metacatUrl);
+			my $lastRev = $metacat->getLastRevision($FORM::docid);
+			$$templateVars{'docid'} = $FORM::docid . "." . $lastRev;
+		}
+		else {
+			$$templateVars{'docid'} = $FORM::docid;
+		}
+		modifyData();
+	}
+	exit();
 
-        # Hence, send back entry form for entry of data.  
-        debug("Sending form");
-        my @sortedSites;
-        foreach my $site (sort @sitelist) {
-            push(@sortedSites, $site);
-        }
+}
+elsif ( $FORM::stage =~ "delete_confirm" ) {
 
-        if ($skinName eq 'nceas') {
-            my $projects = getProjectList($properties);
-            $$templateVars{'projects'} = $projects;
-            $$templateVars{'wg'} = \@FORM::wg;
-        }
+	# Result from deleteData form.
+	if ( $FORM::deleteData =~ "Delete document" ) {
 
-        $$templateVars{'modules'} = $modules;
-        $$templateVars{'required'} = $required;
-        $$templateVars{'templates'} = $templates;
-        $$templateVars{'show'} = $show;
-        $$templateVars{'site'} = $config->{'site'};
+		# delete Data
+		deleteData(1);
+		exit();
+	}
+	else {
+		$$templateVars{'status'}   = "Cancel";
+		$$templateVars{'function'} = "cancel";
+		$template->process( $templates->{'response'}, $templateVars );
+		exit();
+	}
 
-        $$templateVars{'siteList'} = \@sortedSites;
-        $$templateVars{'section'} = "Entry Form";
-        $$templateVars{'docid'} = "";
-        debug("Sending form: ready to process template");
-        $template->process($templates->{'entry'}, $templateVars);
-        debug("Sending form: template processed");
-   }
-   exit();
 }
+elsif ( $FORM::stage =~ "delete" ) {
 
-# Confirm stage has been reached. Enter the data into metacat. 
+	# Deletion of a file has been requested.
+	# Ask for username and password using deleteDataForm
+	$$templateVars{'docid'} = $FORM::docid;
+	$template->process( $templates->{'deleteData'}, $templateVars );
+	exit();
 
+}
+elsif ( $FORM::stage !~ "confirmed" ) {
+
+	# None of the stages have been reached and data is not being confirmed.
+
+	# check if the user is logged in...
+	my $session = CGI::Session->load() or die CGI::Session->errstr();
+	if ( $session->is_empty ) {
+
+		# no session found ... redirect to login page template
+		$$templateVars{'showInstructions'} = 'true';
+		$$templateVars{'message'} = 'You must login to register your dataset.';
+		$template->process( $templates->{'login'}, $templateVars );
+	}
+	else {
+
+		# Hence, send back entry form for entry of data.
+		debug("Sending form");
+		my @sortedSites;
+		foreach my $site ( sort @sitelist ) {
+			push( @sortedSites, $site );
+		}
+
+		if ( $skinName eq 'nceas' ) {
+			my $projects = getProjectList($properties);
+			$$templateVars{'projects'} = $projects;
+			$$templateVars{'wg'}       = \@FORM::wg;
+		}
+
+		$$templateVars{'modules'}   = $modules;
+		$$templateVars{'required'}  = $required;
+		$$templateVars{'templates'} = $templates;
+		$$templateVars{'show'}      = $show;
+		$$templateVars{'site'}      = $config->{'site'};
+
+		$$templateVars{'siteList'} = \@sortedSites;
+		$$templateVars{'section'}  = "Entry Form";
+		$$templateVars{'docid'}    = "";
+		debug("Sending form: ready to process template");
+		$template->process( $templates->{'entry'}, $templateVars );
+		debug("Sending form: template processed");
+	}
+	exit();
+}
+
+# Confirm stage has been reached. Enter the data into metacat.
+
 # Initialize some global vars
-my $latDeg1 = "";
-my $latMin1 = "";
-my $latSec1 = "";
-my $hemisphLat1 = "";
-my $longDeg1 = "";
-my $longMin1 = "";
-my $longSec1 = "";
+my $latDeg1      = "";
+my $latMin1      = "";
+my $latSec1      = "";
+my $hemisphLat1  = "";
+my $longDeg1     = "";
+my $longMin1     = "";
+my $longSec1     = "";
 my $hemisphLong1 = "";
-my $latDeg2 = "";
-my $latMin2 = "";
-my $latSec2 = "";
-my $hemisphLat2 = "";
-my $longDeg2 = "";
-my $longMin2 = "";
-my $longSec2 = "";
+my $latDeg2      = "";
+my $latMin2      = "";
+my $latSec2      = "";
+my $hemisphLat2  = "";
+my $longDeg2     = "";
+my $longMin2     = "";
+my $longSec2     = "";
 my $hemisphLong2 = "";
-my $modUsername = "";
-my $modPassword = "";
+my $modUsername  = "";
+my $modPassword  = "";
 
 # validate the input form parameters
 my $invalidParams;
 
-if (! $error) {
-    $invalidParams = validateParameters(1);
-    if (scalar(@$invalidParams)) {
-        $$templateVars{'status'} = 'failure';
-        $$templateVars{'invalidParams'} = $invalidParams;
-        $error = 1;
-    }
+if ( !$error ) {
+	$invalidParams = validateParameters(1);
+	if ( scalar(@$invalidParams) ) {
+		$$templateVars{'status'}        = 'failure';
+		$$templateVars{'invalidParams'} = $invalidParams;
+		$error                          = 1;
+	}
 }
 
+my $docid;
 
-my $docid;
 # Create a metacat object
 my $metacat = Metacat->new($metacatUrl);
 
-if (! $error) {
-    # Login to metacat
-    my ($username, $password) = getCredentials();
-    my $response = $metacat->login($username, $password);
-    my $errorMessage = "";
+if ( !$error ) {
 
-    # Parameters have been validated and Create the XML document
-    my $xmldoc = createXMLDocument();
-    
-    my $xmldocWithDocID = $xmldoc;
-    my $errorMessage = "";
+	# Login to metacat
+	my ( $username, $password ) = getCredentials();
+	my $response = $metacat->login( $username, $password );
+	my $errorMessage = "";
 
-    if (! $response) {
-        debug("No response from Metacat");
-        push(@errorMessages, $metacat->getMessage());
-        push(@errorMessages, "Failed during login.\n");
-        $$templateVars{'status'} = 'login_failure';
-        $$templateVars{'errorMessages'} = \@errorMessages;
-        $$templateVars{'docid'} = $docid;
-        $$templateVars{'cfg'} = $skinName;
-        $$templateVars{'function'} = "submitted";
-        $$templateVars{'section'} = "Submission Status";
-        $template->process($templates->{'response'}, $templateVars);
-        exit();
-    } else {
+	# Parameters have been validated and Create the XML document
+	my $xmldoc = createXMLDocument();
 
-    if ($config->{'adminIsDocOwner'} eq 'true') {
-        debug("adminIsDocOwner is set.");
-        $response = $metacat->login($adminUsername, $adminPassword);
-        if (! $response) {
-            push(@errorMessages, $metacat->getMessage());
-            push(@errorMessages, "Failed during login for admin.\n");
-            $$templateVars{'status'} = 'login_failure';
-            $$templateVars{'errorMessages'} = \@errorMessages;
-            $$templateVars{'docid'} = $docid;
-            $$templateVars{'cfg'} = $skinName;
-            $$templateVars{'function'} = "submitted";
-            $$templateVars{'section'} = "Submission Status";
-            $template->process($templates->{'response'}, $templateVars);
-            exit();
-        }
-    }
+	my $xmldocWithDocID = $xmldoc;
+	my $errorMessage    = "";
 
-        debug("A");
-        if ($FORM::docid eq "") {
-            debug("B1");
-            # document is being inserted 
-            my $docStatus = "INCOMPLETE";
-            while ($docStatus eq "INCOMPLETE") {
-                $docid = newAccessionNumber($config->{'scope'}, $metacat);
+	if ( !$response ) {
+		debug("No response from Metacat");
+		push( @errorMessages, $metacat->getMessage() );
+		push( @errorMessages, "Failed during login.\n" );
+		$$templateVars{'status'}        = 'login_failure';
+		$$templateVars{'errorMessages'} = \@errorMessages;
+		$$templateVars{'docid'}         = $docid;
+		$$templateVars{'cfg'}           = $skinName;
+		$$templateVars{'function'}      = "submitted";
+		$$templateVars{'section'}       = "Submission Status";
+		$template->process( $templates->{'response'}, $templateVars );
+		exit();
+	}
+	else {
 
-                $xmldocWithDocID =~ s/docid/$docid/;
-                debugDoc($xmldocWithDocID);
-                $docStatus = insertMetadata($xmldocWithDocID, $docid);
-            }
-            debug("B2");
-            if ($docStatus ne "SUCCESS") {
-                debug("NO SUCCESS");
-                debug("Message is: $docStatus");
-                push(@errorMessages, $docStatus);
-            } else {
-                deleteRemovedData();
-            }
+		if ( $config->{'adminIsDocOwner'} eq 'true' ) {
+			debug("adminIsDocOwner is set.");
+			$response = $metacat->login( $adminUsername, $adminPassword );
+			if ( !$response ) {
+				push( @errorMessages, $metacat->getMessage() );
+				push( @errorMessages, "Failed during login for admin.\n" );
+				$$templateVars{'status'}        = 'login_failure';
+				$$templateVars{'errorMessages'} = \@errorMessages;
+				$$templateVars{'docid'}         = $docid;
+				$$templateVars{'cfg'}           = $skinName;
+				$$templateVars{'function'}      = "submitted";
+				$$templateVars{'section'}       = "Submission Status";
+				$template->process( $templates->{'response'}, $templateVars );
+				exit();
+			}
+		}
 
-            debug("B3");
-        } else {
-            debug("M1");
+		debug("A");
+		if ( $FORM::docid eq "" ) {
+			debug("B1");
 
-            # document is being modified
-            $docid = incrementRevision($FORM::docid);
+			# document is being inserted
+			my $docStatus = "INCOMPLETE";
+			while ( $docStatus eq "INCOMPLETE" ) {
+				$docid = newAccessionNumber( $config->{'scope'}, $metacat );
 
-            $xmldoc =~ s/docid/$docid/;
-            debugDoc($xmldoc);
+				$xmldocWithDocID =~ s/docid/$docid/;
+				debugDoc($xmldocWithDocID);
+				$docStatus = insertMetadata( $xmldocWithDocID, $docid );
+			}
+			debug("B2");
+			if ( $docStatus ne "SUCCESS" ) {
+				debug("NO SUCCESS");
+				debug("Message is: $docStatus");
+				push( @errorMessages, $docStatus );
+			}
+			else {
+				deleteRemovedData();
+			}
 
-            my $response = $metacat->update($docid, $xmldoc);
+			debug("B3");
+		}
+		else {
+			debug("M1");
 
-            if (! $response) {
-                push(@errorMessages, $metacat->getMessage());
-                push(@errorMessages, "Failed while updating.\n");  
-            } 
-                     
-            debug("M2, $docid");
-            if (scalar(@errorMessages)) {
-                debug("Errors defined in modify.");
+			# document is being modified
+			$docid = incrementRevision($FORM::docid);
 
-                $$templateVars{'docid'} = $FORM::docid;
-                copyFormToTemplateVars();
-                $$templateVars{'status'} = 'failure';
-                $$templateVars{'errorMessages'} = \@errorMessages;
-                $error = 1;
-            } else {
-                deleteRemovedData();
-                $$templateVars{'docid'} = $docid;
-                $$templateVars{'cfg'} = $skinName;
-            }
+			$xmldoc =~ s/docid/$docid/;
+			debugDoc($xmldoc);
 
-            # Create our HTML response and send it back
-            $$templateVars{'function'} = "modified";
-            $$templateVars{'section'} = "Modification Status";
-            $template->process($templates->{'response'}, $templateVars);
+			my $response = $metacat->update( $docid, $xmldoc );
 
-            exit();
-        }
-    }
+			if ( !$response ) {
+				push( @errorMessages, $metacat->getMessage() );
+				push( @errorMessages, "Failed while updating.\n" );
+			}
+
+			debug("M2, $docid");
+			if ( scalar(@errorMessages) ) {
+				debug("Errors defined in modify.");
+
+				$$templateVars{'docid'} = $FORM::docid;
+				copyFormToTemplateVars();
+				$$templateVars{'status'}        = 'failure';
+				$$templateVars{'errorMessages'} = \@errorMessages;
+				$error                          = 1;
+			}
+			else {
+				deleteRemovedData();
+				$$templateVars{'docid'} = $docid;
+				$$templateVars{'cfg'}   = $skinName;
+			}
+
+			# Create our HTML response and send it back
+			$$templateVars{'function'} = "modified";
+			$$templateVars{'section'}  = "Modification Status";
+			$template->process( $templates->{'response'}, $templateVars );
+
+			# send a notification email to the moderator
+			if ( hasContent($FORM::cfg) && $FORM::cfg eq 'esa' ) {
+				my $title               = "";
+				my $contactEmailAddress = "";
+				my $contactName         = "";
+				my $parser              = XML::LibXML->new();
+				my $parsedDoc           = $parser->parse_string($xmldoc);
+				$FORM::function = 'modified';
+
+				my $findNodes = $parsedDoc->findnodes('//dataset/title');
+				if ( $findNodes->size() > 0 ) {
+
+					# found title
+					my $node = '';
+					foreach $node ( $findNodes->get_nodelist ) {
+						$title = findValue( $node, '../title' );
+					}
+				}
+
+				$findNodes = $parsedDoc->findnodes('//dataset/contact');
+				if ( $findNodes->size() > 0 ) {
+
+					# found contact email address
+					my $node = '';
+					foreach $node ( $findNodes->get_nodelist ) {
+						my $surName =
+						  findValue( $node, 'individualName/surName' );
+						my $givenName =
+						  findValue( $node, 'individualName/givenName' );
+						my $organizationName =
+						  findValue( $node, 'organizationName' );
+
+						if ( $surName ne '' ) {
+							$contactName = $givenName . ' ' . $surName;
+						}
+						else {
+							$contactName = $organizationName;
+						}
+					}
+				}
+
+				$FORM::docid = $docid;
+
+				modSendNotification( $title, $contactEmailAddress, $contactName,
+					"Document $docid modification review pending" );
+			}
+			exit();
+		}
+	}
+
+	if ( hasContent($FORM::cfg) && $FORM::cfg eq 'esa' ) {
+		my $title               = "";
+		my $contactEmailAddress = "";
+		my $contactName         = "";
+		my $parser              = XML::LibXML->new();
+		my $parsedDoc           = $parser->parse_string($xmldoc);
+
+		my $findNodes = $parsedDoc->findnodes('//dataset/title');
+		if ( $findNodes->size() > 0 ) {
+
+			# found title
+			my $node = '';
+			foreach $node ( $findNodes->get_nodelist ) {
+				$title = findValue( $node, '../title' );
+			}
+		}
+
+		$findNodes = $parsedDoc->findnodes('//dataset/contact');
+		if ( $findNodes->size() > 0 ) {
+
+			# found contact email address
+			my $node = '';
+			foreach $node ( $findNodes->get_nodelist ) {
+				$contactEmailAddress = findValue( $node, 'electronicMailAddress' );
+				my $surName   = findValue( $node, 'individualName/surName' );
+				my $givenName = findValue( $node, 'individualName/givenName' );
+				my $organizationName = findValue( $node, 'organizationName' );
+
+				if ( $surName ne '' ) {
+					$contactName = $givenName . ' ' . $surName;
+				}
+				else {
+					$contactName = $organizationName;
+				}
+			}
+		}
+		$FORM::docid = $docid;
+
+		modSendNotification( $title, $contactEmailAddress, $contactName,
+			"Document $docid review pending" );
+	}
 }
 
 debug("C");
 
-if (scalar(@errorMessages)) {
-    debug("ErrorMessages defined.");
-    $$templateVars{'docid'} = $FORM::docid;
-    copyFormToTemplateVars();
-    $$templateVars{'status'} = 'failure';
-    $$templateVars{'errorMessages'} = \@errorMessages;
-    $error = 1;
-} else {
-    $$templateVars{'docid'} = $docid;
-    $$templateVars{'cfg'} = $skinName;
-    # delete the remaining file objects from disk
-    for (my $fileNum = 0; $fileNum <= $FORM::upCount; $fileNum++) {
-        my $fn = 'uploadname_' . $fileNum;
-        if (hasContent(param($fn))) {
-            deleteFile(param($fn));
-        }
-    }
-    
+if ( scalar(@errorMessages) ) {
+	debug("ErrorMessages defined.");
+	$$templateVars{'docid'} = $FORM::docid;
+	copyFormToTemplateVars();
+	$$templateVars{'status'}        = 'failure';
+	$$templateVars{'errorMessages'} = \@errorMessages;
+	$error                          = 1;
 }
+else {
+	$$templateVars{'docid'} = $docid;
+	$$templateVars{'cfg'}   = $skinName;
 
+	# delete the remaining file objects from disk
+	for ( my $fileNum = 0 ; $fileNum <= $FORM::upCount ; $fileNum++ ) {
+		my $fn = 'uploadname_' . $fileNum;
+		if ( hasContent( param($fn) ) ) {
+			deleteFile( param($fn) );
+		}
+	}
+
+}
+
 # Create our HTML response and send it back
 $$templateVars{'function'} = "submitted";
-$$templateVars{'section'} = "Submission Status";
+$$templateVars{'section'}  = "Submission Status";
 
-$template->process($templates->{'response'}, $templateVars);
+$template->process( $templates->{'response'}, $templateVars );
 
 exit();
 
@@ -530,29 +669,31 @@
 #
 ################################################################################
 sub insertMetadata {
-  my $xmldoc = shift;
-  my $docid = shift;
+	my $xmldoc = shift;
+	my $docid  = shift;
 
-  debug("Trying to insert the following document");
-  my $docStatus = "SUCCESS";
-  debug("Starting insert (D1)");
+	debug("Trying to insert the following document");
+	my $docStatus = "SUCCESS";
+	debug("Starting insert (D1)");
 
-  my $response = $metacat->insert($docid, $xmldoc);
-  if (! $response) {
-    debug("Response gotten (D2)");
-    my $errormsg = $metacat->getMessage();i
-    debug("Error is (D3): " . $errormsg);
-    if ($errormsg =~ /is already in use/) {
-        $docStatus = "INCOMPLETE";
-    } elsif ($errormsg =~ /<login>/) {
-        $docStatus = "SUCCESS";
-    } else { 
-        $docStatus = $errormsg;
-    }
-  }
-  debug("Ending insert (D4)");
+	my $response = $metacat->insert( $docid, $xmldoc );
+	if ( !$response ) {
+		debug("Response gotten (D2)");
+		my $errormsg = $metacat->getMessage();
+		i debug( "Error is (D3): " . $errormsg );
+		if ( $errormsg =~ /is already in use/ ) {
+			$docStatus = "INCOMPLETE";
+		}
+		elsif ( $errormsg =~ /<login>/ ) {
+			$docStatus = "SUCCESS";
+		}
+		else {
+			$docStatus = $errormsg;
+		}
+	}
+	debug("Ending insert (D4)");
 
-  return $docStatus;
+	return $docStatus;
 }
 
 ################################################################################
